Index: trunk/Cocoa/Pester/Source/NSCalendarDate-OFExtensions.h
===================================================================
--- trunk/Cocoa/Pester/Source/NSCalendarDate-OFExtensions.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/NSCalendarDate-OFExtensions.h	(revision 102)
@@ -0,0 +1,25 @@
+// Copyright 1997-2002 Omni Development, Inc.  All rights reserved.
+//
+// This software may only be used and reproduced according to the
+// terms in the file OmniSourceLicense.html, which should be
+// distributed with this project and can also be found at
+// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
+//
+// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniFoundation/OpenStepExtensions.subproj/NSCalendarDate-OFExtensions.h,v 1.12 2002/03/09 01:54:02 kc Exp $
+
+#import <Foundation/NSCalendarDate.h>
+
+@interface NSCalendarDate (OFExtensions)
++ (NSCalendarDate *)unixReferenceDate;
+- (void)setToUnixDateFormat;
+- initWithTime_t:(int)time;
+
+- (NSCalendarDate *)safeReferenceDate;
+- (NSCalendarDate *)firstDayOfMonth;
+- (NSCalendarDate *)lastDayOfMonth;
+- (int)numberOfDaysInMonth;
+- (int)weekOfMonth;
+    // Returns 1 through 6. Weeks are Sunday-Saturday.
+- (BOOL)isInSameWeekAsDate:(NSCalendarDate *)otherDate;
+
+@end
Index: trunk/Cocoa/Pester/Source/NSCalendarDate-OFExtensions.m
===================================================================
--- trunk/Cocoa/Pester/Source/NSCalendarDate-OFExtensions.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/NSCalendarDate-OFExtensions.m	(revision 102)
@@ -0,0 +1,120 @@
+// Copyright 1997-2002 Omni Development, Inc.  All rights reserved.
+//
+// This software may only be used and reproduced according to the
+// terms in the file OmniSourceLicense.html, which should be
+// distributed with this project and can also be found at
+// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
+
+#import "NSCalendarDate-OFExtensions.h"
+
+#import <Foundation/Foundation.h>
+
+// RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniFoundation/OpenStepExtensions.subproj/NSCalendarDate-OFExtensions.m,v 1.15 2002/03/09 01:54:02 kc Exp $")
+
+@implementation NSCalendarDate (OFExtensions)
+
++ (NSCalendarDate *)unixReferenceDate;
+{
+    static NSCalendarDate *unixReferenceDate = nil;
+    const long zero = 0;
+
+    if (unixReferenceDate == nil) {
+        unixReferenceDate = [[NSCalendarDate dateWithString:[NSString stringWithCString:ctime(&zero)] calendarFormat:@"%a %b %d %H:%M:%S %Y\n"] retain];
+    }
+    return unixReferenceDate;
+}
+
+- (void)setToUnixDateFormat;
+{
+    if ([self yearOfCommonEra] == [(NSCalendarDate *)[NSCalendarDate date] yearOfCommonEra])
+	[self setCalendarFormat:@"%b %d %H:%M"];
+    else
+	[self setCalendarFormat:@"%b %d %Y"];
+}
+
+- initWithTime_t:(int)time;
+{
+    NSCalendarDate *date;
+
+    date = (id)[self initWithTimeInterval:time sinceDate:[isa unixReferenceDate]];
+    [date setToUnixDateFormat];
+    return date;
+}
+
+// We're going with Noon instead of midnight, since it's a bit more tolerant of
+// time zone switching. (When you're adding days.)
+
+- (NSCalendarDate *)safeReferenceDate;
+{
+    int year, month, day;
+
+    year = [self yearOfCommonEra];
+    month = [self monthOfYear];
+    day = [self dayOfMonth];
+
+    return [NSCalendarDate dateWithYear:year month:month day:day
+                           hour:12 minute:0 second:0 timeZone:[NSTimeZone localTimeZone]];
+}
+
+- (NSCalendarDate *)firstDayOfMonth;
+{
+    NSCalendarDate *firstDay;
+
+    firstDay = [[NSCalendarDate alloc] initWithYear:[self yearOfCommonEra]
+        month:[self monthOfYear]
+        day:1
+        hour:12
+        minute:0
+        second:0
+        timeZone:nil];
+    return [firstDay autorelease];
+}
+
+- (NSCalendarDate *)lastDayOfMonth;
+{
+    return [[self firstDayOfMonth] dateByAddingYears:0 months:1 days:-1 hours:0 minutes:0 seconds:0];
+}
+
+- (int)numberOfDaysInMonth;
+{
+    return [[self lastDayOfMonth] dayOfMonth];
+}
+
+- (int)weekOfMonth;
+{
+    // Returns 1 through 6. Weeks are Sunday-Saturday.
+    int dayOfMonth;
+    int firstWeekDayOfMonth;
+    
+    dayOfMonth = [self dayOfMonth];
+    firstWeekDayOfMonth = [[self firstDayOfMonth] dayOfWeek];
+    return (dayOfMonth - 1 + firstWeekDayOfMonth) / 7 + 1;
+}
+
+- (BOOL)isInSameWeekAsDate:(NSCalendarDate *)otherDate;
+{
+    int weekOfMonth;
+
+    // First, do a quick check to filter out dates which are more than a week away.
+    if (abs([self dayOfCommonEra] - [otherDate dayOfCommonEra]) > 6)
+        return NO;
+
+    // Then, handle the simple case, when both dates are the same year and month.
+    if ([self yearOfCommonEra] == [otherDate yearOfCommonEra] && [self monthOfYear] == [otherDate monthOfYear])
+        return ([self weekOfMonth] == [otherDate weekOfMonth]);
+
+    // Now we know the other date is within a week of us, and not in the same month. 
+    weekOfMonth = [self weekOfMonth];
+    if (weekOfMonth == 1) {
+        // We are in the first week of the month. The otherDate is in the same week if its weekday is earlier than ours.
+        return ([otherDate dayOfWeek] < [self dayOfWeek]);
+    } else if (weekOfMonth == [[self lastDayOfMonth] weekOfMonth]) {
+        // We are in the last week of the month. The otherDate is in the same week if its weekday is later than ours.
+        return ([otherDate dayOfWeek] > [self dayOfWeek]);
+    } else {
+        // We are somewhere in the middle of the month, so the otherDate cannot be in the same week.
+        return NO;
+    }
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/NSImage-OAExtensions.h
===================================================================
--- trunk/Cocoa/Pester/Source/NSImage-OAExtensions.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/NSImage-OAExtensions.h	(revision 102)
@@ -0,0 +1,28 @@
+// Copyright 1997-2002 Omni Development, Inc.  All rights reserved.
+//
+// This software may only be used and reproduced according to the
+// terms in the file OmniSourceLicense.html, which should be
+// distributed with this project and can also be found at
+// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
+//
+// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniAppKit/OpenStepExtensions.subproj/NSImage-OAExtensions.h,v 1.14 2002/03/09 01:53:54 kc Exp $
+
+#import <AppKit/NSImage.h>
+
+@class NSMutableSet;
+
+@interface NSImage (OAExtensions)
+
++ (NSImage *)imageNamed:(NSString *)imageName inBundleForClass:(Class)aClass;
++ (NSImage *)imageNamed:(NSString *)imageName inBundle:(NSBundle *)aBundle;
++ (NSImage *)imageForFileType:(NSString *)fileType;
+    // Caching wrapper for -[NSWorkspace iconForFileType:].  This method is not thread-safe at the moment.
++ (NSImage *)draggingIconWithTitle:(NSString *)title andImage:(NSImage *)image;
+
+- (void)drawFlippedInRect:(NSRect)rect operation:(NSCompositingOperation)op fraction:(float)delta;
+- (void)drawFlippedInRect:(NSRect)rect operation:(NSCompositingOperation)op;
+
+    // Puts the image on the pasteboard as TIFF, and also supplies data from any PDF, EPS, or PICT representations available. Returns the number of types added to the pasteboard and adds their names to notThese. This routine uses -addTypes:owner:, so the pasteboard must have previously been set up using -declareTypes:owner.
+- (int)addDataToPasteboard:(NSPasteboard *)aPasteboard exceptTypes:(NSMutableSet *)notThese;
+
+@end
Index: trunk/Cocoa/Pester/Source/NSImage-OAExtensions.m
===================================================================
--- trunk/Cocoa/Pester/Source/NSImage-OAExtensions.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/NSImage-OAExtensions.m	(revision 102)
@@ -0,0 +1,211 @@
+// Copyright 1997-2002 Omni Development, Inc.  All rights reserved.
+//
+// This software may only be used and reproduced according to the
+// terms in the file OmniSourceLicense.html, which should be
+// distributed with this project and can also be found at
+// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
+
+#import "NSImage-OAExtensions.h"
+
+#import <AppKit/AppKit.h>
+
+// RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniAppKit/OpenStepExtensions.subproj/NSImage-OAExtensions.m,v 1.17 2002/03/09 01:53:54 kc Exp $")
+
+@implementation NSImage (OAExtensions)
+
++ (NSImage *)imageNamed:(NSString *)imageName inBundleForClass:(Class)aClass;
+{
+    return [self imageNamed:imageName inBundle:[NSBundle bundleForClass:aClass]];
+}
+
++ (NSImage *)imageNamed:(NSString *)imageName inBundle:(NSBundle *)aBundle;
+{
+    NSImage *image;
+    NSString *path;
+
+    image = [self imageNamed:imageName];
+    if (image && [image size].width != 0)
+        return image;
+
+    path = [aBundle pathForImageResource:imageName];
+    if (!path)
+        return nil;
+
+    image = [[NSImage alloc] initWithContentsOfFile:path];
+    [image setName:imageName];
+
+    return image;
+}
+
++ (NSImage *)imageForFileType:(NSString *)fileType;
+    // It turns out that -[NSWorkspace iconForFileType:] doesn't cache previously returned values, so we cache them here.
+{
+    static NSMutableDictionary *imageDictionary = nil;
+    id image;
+
+    // ASSERT_IN_MAIN_THREAD(@"+imageForFileType: is not thread-safe; must be called from the main thread");
+    // We could fix this by adding locks around imageDictionary
+
+    if (!fileType)
+        return nil;
+        
+    if (imageDictionary == nil)
+        imageDictionary = [[NSMutableDictionary alloc] init];
+
+    image = [imageDictionary objectForKey:fileType];
+    if (image == nil) {
+#ifdef DEBUG
+        // Make sure that our caching doesn't go insane (and that we don't ask it to cache insane stuff)
+        NSLog(@"Caching workspace image for file type '%@'", fileType);
+#endif
+        image = [[NSWorkspace sharedWorkspace] iconForFileType:fileType];
+        if (image == nil)
+            image = [NSNull null];
+        [imageDictionary setObject:image forKey:fileType];
+    }
+    return image != [NSNull null] ? image : nil;
+}
+
+#define X_SPACE_BETWEEN_ICON_AND_TEXT_BOX 2
+#define X_TEXT_BOX_BORDER 2
+#define Y_TEXT_BOX_BORDER 2
+static NSDictionary *titleFontAttributes;
+
++ (NSImage *)draggingIconWithTitle:(NSString *)title andImage:(NSImage *)image;
+{
+    NSImage *drawImage;
+    NSSize imageSize, totalSize;
+    NSSize titleSize, titleBoxSize;
+    NSRect titleBox;
+    NSPoint textPoint;
+
+    NSParameterAssert(image != nil);
+    imageSize = [image size];
+
+    if (!titleFontAttributes)
+        titleFontAttributes = [[NSDictionary alloc] initWithObjectsAndKeys:[NSFont systemFontOfSize:12.0], NSFontAttributeName, [NSColor textColor], NSForegroundColorAttributeName, nil];
+
+    if (!title || [title length] == 0)
+        return image;
+    
+    titleSize = [title sizeWithAttributes:titleFontAttributes];
+    titleBoxSize = NSMakeSize(titleSize.width + 2.0 * X_TEXT_BOX_BORDER, titleSize.height + Y_TEXT_BOX_BORDER);
+
+    totalSize = NSMakeSize(imageSize.width + X_SPACE_BETWEEN_ICON_AND_TEXT_BOX + titleBoxSize.width, MAX(imageSize.height, titleBoxSize.height));
+
+    drawImage = [[NSImage alloc] initWithSize:totalSize];
+    [drawImage setFlipped:YES];
+
+    [drawImage lockFocus];
+
+    // Draw transparent background
+    [[NSColor colorWithDeviceWhite:1.0 alpha:0.0] set];
+    NSRectFill(NSMakeRect(0, 0, totalSize.width, totalSize.height));
+
+    // Draw icon
+    [image compositeToPoint:NSMakePoint(0.0, rint(totalSize.height / 2.0 + imageSize.height / 2.0)) operation:NSCompositeSourceOver];
+    
+    // Draw box around title
+    titleBox = NSMakeRect(imageSize.width + X_SPACE_BETWEEN_ICON_AND_TEXT_BOX, floor((totalSize.height - titleBoxSize.height)/2.0), titleBoxSize.width, titleBoxSize.height);
+    [[[NSColor selectedTextBackgroundColor] colorWithAlphaComponent:0.5] set];
+    NSRectFill(titleBox);
+
+    // Draw title
+    textPoint = NSMakePoint(imageSize.width + X_SPACE_BETWEEN_ICON_AND_TEXT_BOX + X_TEXT_BOX_BORDER, Y_TEXT_BOX_BORDER - 1);
+
+    [title drawAtPoint:textPoint withAttributes:titleFontAttributes];
+
+    [drawImage unlockFocus];
+
+    return [drawImage autorelease];
+}
+
+//
+
+- (void)drawFlippedInRect:(NSRect)rect operation:(NSCompositingOperation)op fraction:(float)delta;
+{
+    CGContextRef context;
+
+    context = [[NSGraphicsContext currentContext] graphicsPort];
+    CGContextSaveGState(context); {
+        CGContextTranslateCTM(context, 0, NSMaxY(rect));
+        CGContextScaleCTM(context, 1, -1);
+        
+        rect.origin.y = 0; // We've translated ourselves so it's zero
+        [self drawInRect:rect fromRect:NSZeroRect operation:op fraction:delta];
+    } CGContextRestoreGState(context);
+
+    /*
+        NSAffineTransform *flipTransform;
+        NSPoint transformedPoint;
+        NSSize transformedSize;
+        NSRect transformedRect;
+
+        flipTransform = [[NSAffineTransform alloc] init];
+        [flipTransform scaleXBy:1.0 yBy:-1.0];
+
+        transformedPoint = [flipTransform transformPoint:rect.origin];
+        transformedSize = [flipTransform transformSize:rect.size];
+        [flipTransform concat];
+        transformedRect = NSMakeRect(transformedPoint.x, transformedPoint.y + transformedSize.height, transformedSize.width, -transformedSize.height);
+        [anImage drawInRect:transformedRect fromRect:NSZeroRect operation:NSCompositeSourceOver fraction:1.0];
+        [flipTransform concat];
+        [flipTransform release];
+        */
+}
+
+- (void)drawFlippedInRect:(NSRect)rect operation:(NSCompositingOperation)op;
+{
+    [self drawFlippedInRect:rect operation:op fraction:1.0];
+}
+
+- (int)addDataToPasteboard:(NSPasteboard *)aPasteboard exceptTypes:(NSMutableSet *)notThese
+{
+    NSArray *myRepresentations;
+    int repIndex, repCount;
+    int count = 0;
+
+    if (!notThese)
+        notThese = [NSMutableSet set];
+
+#define IF_ADD(typename, dataOwner) if( ![notThese containsObject:(typename)] && [aPasteboard addTypes:[NSArray arrayWithObject:(typename)] owner:(dataOwner)] > 0 )
+
+#define ADD_CHEAP_DATA(typename, expr) IF_ADD(typename, nil) { [aPasteboard setData:(expr) forType:(typename)]; [notThese addObject:(typename)]; count ++; }
+        
+    /* If we have image representations lying around that already have data in some concrete format, add that data to the pasteboard. */
+    myRepresentations = [self representations];
+    repCount = [myRepresentations count];
+    for(repIndex = 0; repIndex < repCount; repIndex ++) {
+        NSImageRep *aRep = [myRepresentations objectAtIndex:repIndex];
+            
+        if ([aRep respondsToSelector:@selector(PDFRepresentation)]) {
+            ADD_CHEAP_DATA(NSPDFPboardType, [(NSPDFImageRep *)aRep PDFRepresentation]);
+        }
+
+        if ([aRep respondsToSelector:@selector(PICTRepresentation)]) {
+            ADD_CHEAP_DATA(NSPICTPboardType, [(NSPICTImageRep *)aRep PICTRepresentation]);
+        }
+
+        if ([aRep respondsToSelector:@selector(EPSRepresentation)]) {
+            ADD_CHEAP_DATA(NSPostScriptPboardType, [(NSEPSImageRep *)aRep EPSRepresentation]);
+        }
+    }
+    
+    /* Always offer to convert to TIFF. Do this lazily, though, since we probably have to extract it from a bitmap image rep. */
+    IF_ADD(NSTIFFPboardType, self) {
+        count ++;
+    }
+
+    return count;
+}
+
+- (void)pasteboard:(NSPasteboard *)aPasteboard provideDataForType:(NSString *)wanted
+{
+    if ([wanted isEqual:NSTIFFPboardType]) {
+        [aPasteboard setData:[self TIFFRepresentation] forType:NSTIFFPboardType];
+    }
+}
+
+
+
+@end
Index: trunk/Cocoa/Pester/Source/NSString-NJRExtensions.m
===================================================================
--- trunk/Cocoa/Pester/Source/NSString-NJRExtensions.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/NSString-NJRExtensions.m	(revision 102)
@@ -70,5 +70,5 @@
 {
     if ([self sizeWithAttributes: attributes].width > maxWidth) {
-        float width;
+        float width = maxWidth;
         int min = 0, max = [self length], avg;
         NSMutableString *original = [self mutableCopy];
Index: trunk/Cocoa/Pester/Source/OACalendarView.h
===================================================================
--- trunk/Cocoa/Pester/Source/OACalendarView.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/OACalendarView.h	(revision 102)
@@ -0,0 +1,90 @@
+// Copyright 2001-2002 Omni Development, Inc.  All rights reserved.
+//
+// This software may only be used and reproduced according to the
+// terms in the file OmniSourceLicense.html, which should be
+// distributed with this project and can also be found at
+// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
+//
+// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniAppKit/Widgets.subproj/OACalendarView.h,v 1.16 2002/12/07 00:23:40 andrew Exp $
+
+#import <AppKit/NSControl.h>
+
+@class NSCalendarDate, NSMutableArray;
+@class NSTableHeaderCell, NSTextFieldCell;
+@class OACalendarView;
+
+#import <AppKit/NSNibDeclarations.h>
+
+@interface NSObject (OACalendarViewDelegate)
+- (int)calendarView:(OACalendarView *)aCalendarView highlightMaskForVisibleMonth:(NSCalendarDate *)visibleMonth;
+- (void)calendarView:(OACalendarView *)aCalendarView willDisplayCell:(id)aCell forDate:(NSCalendarDate *)aDate;	// implement this on the target if you want to be able to set up the date cell. The cell is only used for drawing (and is reused for every date), so you can not, for instance, enable/disable dates by enabling or disabling the cell.
+- (BOOL)calendarView:(OACalendarView *)aCalendarView shouldSelectDate:(NSCalendarDate *)aDate;	// implement this on the target if you need to prevent certain dates from being selected. The target is responsible for taking into account the selection type
+- (void)calendarView:(OACalendarView *)aCalendarView didChangeVisibleMonth:(NSCalendarDate *)aDate;	// implement this on the target if you want to know when the visible month changes
+- (void)calendarViewShouldDismiss:(OACalendarView *)aCalendarView;	// implement this on the target if you want to know when someone double-clicks on a day
+@end
+
+
+typedef enum _OACalendarViewSelectionType {
+    OACalendarViewSelectByDay = 0,		// one day
+    OACalendarViewSelectByWeek = 1,		// one week (from Sunday to Saturday) 
+    OACalendarViewSelectByWeekday = 2,    	// all of one weekday (e.g. Monday) for a whole month
+} OACalendarViewSelectionType;
+
+@interface OACalendarView : NSControl
+{
+    NSCalendarDate *visibleMonth;
+    NSCalendarDate *selectedDay;
+    NSMutableString *typed;
+    NSDate *typeSelectResetTime;
+
+    NSView *monthAndYearView;
+    NSTextFieldCell *monthAndYearTextFieldCell;
+    NSTableHeaderCell *dayOfWeekCell[7];
+    NSTextFieldCell *dayOfMonthCell;
+    NSMutableArray *buttons;
+
+    int dayHighlightMask;
+    OACalendarViewSelectionType selectionType;
+    
+    float columnWidth;
+    float rowHeight;
+    NSRect monthAndYearRect;
+    NSRect gridHeaderAndBodyRect;
+    NSRect gridHeaderRect;
+    NSRect gridBodyRect;
+    
+    struct {
+        unsigned int showsDaysForOtherMonths:1;
+        unsigned int targetProvidesHighlightMask:1;
+        unsigned int targetWatchesCellDisplay:1;
+        unsigned int targetWatchesVisibleMonth:1;
+        unsigned int targetApprovesDateSelection:1;
+        unsigned int targetReceivesDismiss:1;
+    } flags;
+}
+
+- (NSCalendarDate *)visibleMonth;
+- (void)setVisibleMonth:(NSCalendarDate *)aDate;
+
+- (NSCalendarDate *)selectedDay;
+- (void)setSelectedDay:(NSCalendarDate *)newSelectedDay;
+
+- (int)dayHighlightMask;
+- (void)setDayHighlightMask:(int)newMask;
+- (void)updateHighlightMask;
+
+- (BOOL)showsDaysForOtherMonths;
+- (void)setShowsDaysForOtherMonths:(BOOL)value;
+
+- (OACalendarViewSelectionType)selectionType;
+- (void)setSelectionType:(OACalendarViewSelectionType)value;
+
+- (NSArray *)selectedDays;
+
+// Actions
+- (IBAction)previousMonth:(id)sender;
+- (IBAction)nextMonth:(id)sender;
+- (IBAction)previousYear:(id)sender;
+- (IBAction)nextYear:(id)sender;
+
+@end
